<?php

namespace InSegment\WorkersFramework\Drivers;

use InSegment\WorkersFramework\Interfaces\DeclareQueueBuilderInterface;

abstract class DeclareBuilderBase implements DeclareQueueBuilderInterface
{
    
    /**
     * @var string
     */
    protected $queueName;
    
    /**
     * @var string
     */
    protected $dlxQueueName;
    
    /**
     * @var int
     */
    protected $messageTtl;
    
    /**
     * {@inheritDoc}
     */
    public function setDlxQueueName(string $dlxQueueName): DeclareQueueBuilderInterface
    {
        $this->dlxQueueName = $dlxQueueName;
        return $this;
    }

    /**
     * {@inheritDoc}
     */
    public function setMessageTtl(int $messageTtl): DeclareQueueBuilderInterface
    {
        $this->messageTtl = $messageTtl;
        return $this;
    }

    /**
     * {@inheritDoc}
     */
    public function setName(string $queueName): DeclareQueueBuilderInterface
    {
        $this->queueName = $queueName;
        return $this;
    }
    

}
