<?php

namespace InSegment\WorkersFramework\Interfaces;

interface ConnectionListInterface
{

    /**
     * Get driver for the given connection
     * 
     * @param string $connection
     * @return \InSegment\WorkersFramework\Interfaces\QueueDriverInterface
     */
    public function getConnection(string $connection): QueueDriverInterface;
    
    /**
     * Get queue by its name
     * 
     * @param string $queueName
     * @return \InSegment\WorkersFramework\Interfaces\QueueInterface
     */
    public function getQueue(string $queueName): QueueInterface;
    
    /**
     * Get queue declare builder
     * 
     * @param \InSegment\WorkersFramework\Interfaces\DeclareQueueBuilderInterface $queueName
     */
    public function declareQueue(string $queueName): DeclareQueueBuilderInterface;
    
}
