<?php

namespace InSegment\WorkersFramework\Interfaces;

use InSegment\WorkersFramework\Interfaces\QueueMessageInterface;

interface QueueDriverInterface
{
    
    /**
     * Declare queues
     * 
     * @return \InSegment\WorkersFramework\Interfaces\DeclareQueueBuilderInterface
     */
    public function declare(): DeclareQueueBuilderInterface;
    
    /**
     * Publish message to the queue
     * 
     * @param \InSegment\WorkersFramework\Interfaces\QueueMessageInterface $message
     * @return \React\Promise\PromiseInterface
     */
    public function publish(QueueMessageInterface $message);
    
    /**
     * Subscribe to queue and return consumer tag
     * 
     * @param string $queueName
     * @param \InSegment\WorkersFramework\Interfaces\ConsumerInterface $reciever
     * @return \React\Promise\PromiseInterface<string>
     */
    public function subscribe(string $queueName, ConsumerInterface $reciever);
    
    /**
     * Un-subscribe from channel
     * 
     * @param string $consumerTag
     * @return \React\Promise\PromiseInterface
     */
    public function unsubscribe(string $consumerTag);
    
}
